; vi:set ts=8 sts=8 sw=8 ft=nasm:
	bits 16
	segment code

..start:
	mov ax, data
	mov ds, ax
	mov ax, stack
	mov ss, ax
	mov sp, stacktop

	mov ax, 13h
	int 10h

	; copy palette
	mov si, logo_pal
	xor cl, cl
pal:	xor eax, eax
	mov dx, 3c8h
	mov al, cl
	out dx, al
	inc dx
	mov al, [si]
	inc si
	shr al, 2
	out dx, al
	mov al, [si]
	inc si
	shr al, 2
	out dx, al
	mov al, [si]
	inc si
	shr al, 2
	out dx, al
	add cl, 1
	jnc pal

	; copy pixels
	push word 0a000h
	pop es
	push word logo_pix
	pop gs
	push word sintab
	pop fs

frameloop:
	xor di, di

	mov word [yval], 0
yloop:	mov word [xval], 0
xloop:	; calc src scanline address -> bx
	mov bx, [yval]
	shl bx, 2
	add bx, [frameno]
	xor bh, bh
	mov cl, [fs:bx]
	xor ch, ch
	shr cx, 5

	mov ax, [yval]
	add ax, cx
	; bounds check
	cmp ax, 200
	jl skip_yclamp
	mov ax, 199

skip_yclamp:
	mov bx, ax
	shl ax, 8
	shl bx, 6
	add bx, ax

	; calc src x offset -> si
	mov ax, [xval]
	shl ax, 2
	add ax, [frameno]
	xor ah, ah
	mov si, ax
	mov cl, [fs:si]
	xor ch, ch
	shr cx, 5

	mov ax, [xval]
	add ax, cx
	; bounds check
	cmp ax, 320
	jl skip_xclamp
	mov ax, 319
skip_xclamp:
	mov si, ax

	mov al, [gs:bx + si]
	mov [es:di], al
	inc di

	inc word [xval]
	cmp word [xval], 320
	jnz xloop

	inc word [yval]
	cmp word [yval], 200
	jnz yloop

	inc word [frameno]

	; wait vsync
	mov dx, 3dah
vs1:	in al, dx
	and al, 8
	jnz vs1
vs2:	in al, dx
	and al, 8
	jz vs2

	; check keyboard
	in al, 60h
	dec al
	jnz frameloop

	mov ax, 3
	int 10h

	mov ax, 4c00h
	int 21h

	segment data
xval dw 0
yval dw 0
frameno dw 0

logo_pal: incbin "logo.pal"

	segment logo_pix
	incbin "logo.raw"

	segment sintab
	db 127
	db 130
	db 133
	db 136
	db 139
	db 143
	db 146
	db 149
	db 152
	db 155
	db 158
	db 161
	db 164
	db 167
	db 170
	db 173
	db 176
	db 179
	db 182
	db 184
	db 187
	db 190
	db 193
	db 195
	db 198
	db 200
	db 203
	db 205
	db 208
	db 210
	db 213
	db 215
	db 217
	db 219
	db 221
	db 224
	db 226
	db 228
	db 229
	db 231
	db 233
	db 235
	db 236
	db 238
	db 239
	db 241
	db 242
	db 244
	db 245
	db 246
	db 247
	db 248
	db 249
	db 250
	db 251
	db 251
	db 252
	db 253
	db 253
	db 254
	db 254
	db 254
	db 254
	db 254
	db 255
	db 254
	db 254
	db 254
	db 254
	db 254
	db 253
	db 253
	db 252
	db 251
	db 251
	db 250
	db 249
	db 248
	db 247
	db 246
	db 245
	db 244
	db 242
	db 241
	db 239
	db 238
	db 236
	db 235
	db 233
	db 231
	db 229
	db 228
	db 226
	db 224
	db 221
	db 219
	db 217
	db 215
	db 213
	db 210
	db 208
	db 205
	db 203
	db 200
	db 198
	db 195
	db 193
	db 190
	db 187
	db 184
	db 182
	db 179
	db 176
	db 173
	db 170
	db 167
	db 164
	db 161
	db 158
	db 155
	db 152
	db 149
	db 146
	db 143
	db 139
	db 136
	db 133
	db 130
	db 127
	db 124
	db 121
	db 118
	db 115
	db 111
	db 108
	db 105
	db 102
	db 99
	db 96
	db 93
	db 90
	db 87
	db 84
	db 81
	db 78
	db 75
	db 72
	db 70
	db 67
	db 64
	db 61
	db 59
	db 56
	db 54
	db 51
	db 49
	db 46
	db 44
	db 41
	db 39
	db 37
	db 35
	db 33
	db 30
	db 28
	db 26
	db 25
	db 23
	db 21
	db 19
	db 18
	db 16
	db 15
	db 13
	db 12
	db 10
	db 9
	db 8
	db 7
	db 6
	db 5
	db 4
	db 3
	db 3
	db 2
	db 1
	db 1
	db 0
	db 0
	db 0
	db 0
	db 0
	db 0
	db 0
	db 0
	db 0
	db 0
	db 0
	db 1
	db 1
	db 2
	db 3
	db 3
	db 4
	db 5
	db 6
	db 7
	db 8
	db 9
	db 10
	db 12
	db 13
	db 15
	db 16
	db 18
	db 19
	db 21
	db 23
	db 25
	db 26
	db 28
	db 30
	db 33
	db 35
	db 37
	db 39
	db 41
	db 44
	db 46
	db 49
	db 51
	db 54
	db 56
	db 59
	db 61
	db 64
	db 67
	db 70
	db 72
	db 75
	db 78
	db 81
	db 84
	db 87
	db 90
	db 93
	db 96
	db 99
	db 102
	db 105
	db 108
	db 111
	db 115
	db 118
	db 121
	db 124

	segment stack stack
	resb 4096
stacktop:
